<?php   

defined('C5_EXECUTE') or die(_("Access Denied."));

class TonyStatsPackage extends Package {

	protected $pkgHandle = 'tony_stats';
	protected $appVersionRequired = '5.3.3';
	protected $pkgVersion = '1.4';
	
	public function getPackageDescription() {
		return t("Monitor your sites traffic, users statistics, and paths");
	}
	
	public function getPackageName() {
		return t("Traffic & Statistics"); 
	}
	
	public function install() {
		$pkg = parent::install();
		
		// install block		
		//BlockType::installBlockTypeFromPackage('tony_stats', $pkg);	
		
		//install dashboard page
		Loader::model('single_page');
		$statsPage=Page::getByPath('/dashboard/stats');
		if( !intval($statsPage->cID) ){ 
			$statsPage=SinglePage::add('/dashboard/stats', $pkg);
		}
		$statsPage->update(array('cName'=>t('Traffic & Statistics'), 'cDescription'=>t('Monitor site visits and user paths')));
		
		$existingTrackingCode=Config::get('SITE_TRACKING_CODE');
		$existingTrackingCode=preg_replace('/<!--STATS JS START-->(.*?)<!--STATS JS END-->/ie','',$existingTrackingCode);
		$script='<script src="'.View::url('/tools/packages/'.$this->pkgHandle.'/services').'?mode=tracker_js" type="text/javascript"></script>';
		$existingTrackingCode.='<!--STATS JS START-->'.$script.'<!--STATS JS END-->';		
		Config::save('SITE_TRACKING_CODE', $existingTrackingCode); 
		
		//install/replace dashboard homepage module
		Loader::model('dashboard/homepage');
		$statsModule=DashboardHomepageView::getByHandle('tony_stats'); 
		if( !$statsModule || !$statsModule->pkgID==$pkg->getPackageID() ){
			
			//set display numbers on homepage modules
			$dh = new DashboardHomepageView();
			$modules = $dh->getModules(); 
			$i=0; 
			foreach($modules as $module){
				$i++;
				if($i==2) $i++;
				$module->dbhDisplayOrder=$i; 
				$module->save();
			} 
			
			//add new module, and set it to the second position
			$statsModule=DashboardHomepageView::add( 'tony_stats', t('Traffic'), $pkg );
			$statsModule->dbhDisplayOrder=2;
			$statsModule->save();
			
			$oldStatsModule=DashboardHomepageView::getByHandle('reports');
			if( $oldStatsModule &&  $oldStatsModule->dbhModule){
				$oldStatsModule->dbhDisplayOrder=1000;
				$oldStatsModule->save();
			}
		}
		
	}
	
	public function uninstall(){
		Loader::model('dashboard/homepage');
		if( method_exists(DashboardHomepageView,'remove') ){
			DashboardHomepageView::remove('tony_stats');
		}else{
			$db=Loader::db();
			$db->query( 'DELETE FROM DashboardHomepage WHERE dbhModule="tony_stats"' );
		} 
		
		$oldStatsModule=DashboardHomepageView::getByHandle('reports');
		if( $oldStatsModule && $oldStatsModule->dbhModule){
			$oldStatsModule->dbhDisplayOrder=2;
			$oldStatsModule->save();
		} 
		
		return parent::uninstall(); 
	}

}