<?php 
/*
ParticleTraffic - Traffic Monitoring
http://stats.particlebook.com

Copyright (c) 2009 Tony Trupp / InnerOptics LLC

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

//Just here to help you to debug
error_reporting(E_ALL ^ E_NOTICE); 


//THE NUMBERED ITEMS INDICATE ELEMENTS YOU NEED TO DISPLAY ParticleTraffic SITE'S DATA DIRECTLY WITHIN YOUR WEBSITE
//==============================================================================================================

// 1) Include the ParticleTraffic library - make sure you config file is setup correctly
require_once(realpath(dirname(__FILE__)).'/ParticleTraffic.config.php');

// Not Required 
if(!ParticleTrafficInstaller::installCheck())
	header('location: '.ParticleTraffic_URL_DIR.'install.php'); 

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>ParticleTraffic - Traffic Monitoring</title>

<?php  /* 2) Include the ParticleTraffic style sheet, javascript, and swfobject */ 
ParticleTrafficDisplay::printHeaderFiles();

/* 3) you need swfobject to display the line chart */
?>
<script src="./js/swfobject/swfobject.js" type="text/javascript"></script>


<?php 
//THIS LINE IS ALL YOU NEED TO TRACK A HIT
//=========================================================
ParticleTrafficTracker::printTrackingJS( ParticleTraffic_SITE_ID_NUMBER );
?>

<?php  /* You don't need this style sheet if you're trying to preserve your own custom look */ ?>
<link href="./css/ParticleTraffic.style.css" rel="stylesheet" type="text/css" /> 

</head>

<body id="ParticleTrafficBody">

<div id="ParticleTrafficPage">
	<?php 
	// 4) Output the display HTML
	//Your site id number is optional, and is used only if you're tracking multiple sites in the same DB.
	$siteIdNumber=0;  
	echo ParticleTrafficDisplay::loadAndDisplay($siteIdNumber);
	?>
	
	<?php  
	/* 
	5) Call the javascript ParticleTraffic.init() function  
	(you can alternatively use a document onload function to call the init if you want)
	*/ 
	?>
	<script type="text/javascript">
	ParticleTraffic.init();
	</script>
</div>

</body>
</html>
