<?php  

if(!defined('ParticleTraffic_PATH')) die;

class ParticleTrafficTools{  
	
	public static function simpleText($text){ 
		return preg_replace("/[^a-z0-9\?\!:@=.,\/\- _&-+\#]/i",'', $text);
	}

	public static function shortText($textStr,$numChars=255,$tail='...'){
		if(intval($numChars)==0) $numChars=150;
		$textStr=strip_tags($textStr);
		if (strlen($textStr)>intval($numChars))			
			$textStr= substr($textStr,0,$numChars).$tail;
		return $textStr;				
	}
	
	/*
	public static function buildIdSegmentedDirPath($id_num=0,$base_folder=''){
		$outerSubPath=floor(intval($id_num)/1000);
		$innerSubPath=intval($id_num)%1000;
		if(substr($base_folder,strlen($base_folder)-1,1)!='/') 
			$base_folder.='/';
		return $base_folder.$outerSubPath.'/'.$innerSubPath.'/';
	}
	*/	
	
	public static function formatPageName($title,$url){
		if(strlen(trim($title))) return ParticleTrafficTools::shortText($title,50);
		else return ParticleTrafficTools::shortText($url,50);
	}
	
	public static function formatPageURL($url){
		return $url;
	}	

	/*
	public static function createPath($path){
		if(!file_exists(ParticleTraffic_CACHE_DIR) || !is_writable(ParticleTraffic_CACHE_DIR) )
		 	throw new Exception('Your ParticleTraffic_CACHE_DIR is setup wrong in ParticleTraffic.config.php.  It must be a valid folder that is writable and readable.');
		
		if(ini_get('safe_mode'))
			throw new Exception('Please disable the php SAFE_MODE setting for ParticleTraffic to work.');
		
		$subpath=str_replace(ParticleTraffic_CACHE_DIR,'',$path);				
		if( substr($subpath,0,1)=='/' ) $subpath=substr($subpath,1);
		$folders=split('/',$subpath);		
		$existingPath= ParticleTraffic_CACHE_DIR;
		$folderCount=count($folders);		
		for($i=0;$i<$folderCount;$i++){
			//$folders as $folder){
			$folder=$folders[$i]; 
			if($folder=='') continue;
			//don't check base path below site		
			if(!file_exists($existingPath.$folder)){  
				echo $existingPath.$folder.'<br>';
				mkdir($existingPath.$folder,0777);
				chown($existingPath.$folder,fileowner($existingPath));
			}
			$existingPath.=$folder.'/';
		}
		if (file_exists($path)) return 1;
		return 0;
	}
	*/
	
	public static function timePast($posttime,$precise=0){
		$timeRemaining=0;
		$diff=date("U")-$posttime;
		$days=intval($diff/(24*60*60));
		$hoursInSecs=$diff-($days*(24*60*60));
		$hours=intval($hoursInSecs/(60*60));
		if ($hours<=0) $hours=$hours+24;			
		if ($posttime>date("U")) return date("n/j/y",$posttime);
		else{
			if ($diff>86400){
					$diff=$diff+86400;
					$days=date("z",$diff);
					$timeRemaining=$days.' day';
					if($days!=1) $timeRemaining.='s';
					if($precise==1) $timeRemaining.=', '.$hours.' hours';
				} else if ($diff>3600) {
					$timeRemaining=$hours.' hour';
					if($hours!=1) $timeRemaining.='s';
					if($precise==1) $timeRemaining.=', '.date("i",$diff).' minutes';
				}else if ($diff>60){
					$minutes=date("i",$diff);
					if(substr($minutes,0,1)=='0') $minutes=substr($minutes,1);
					$timeRemaining=$minutes.' minute';
					if($minutes!=1) $timeRemaining.='s';
					if($precise==1) $timeRemaining.=', '.date("s",$diff).' seconds';
				}else{
					$seconds=date("s",$diff);
					if(substr($seconds,0,1)=='0') $seconds=substr($seconds,1);
					$timeRemaining=$seconds.' second';
					if($seconds!=1) $timeRemaining.='s';
				}
		}
		return $timeRemaining.' ago';
	}
	
	public static function timeLengthLabel($seconds,$precise=0){
		if($seconds<60){
			$str = $seconds.' second';
			if($seconds!=1) $str.='s';
		}elseif($seconds<3600){
			$minutes=floor($seconds/60);
			$str = $minutes.' minute';
			if($minutes!=1) $str.='s';
		}else{ //if($seconds<86400){
			$hours=floor($seconds/3600);
			$str=$hours.' hour';
			if($hours!=1) $str.='s';
		}
		return $str;
	}	
	
	public static function printSpacerImg(){
		$imgPath=ParticleTraffic_PATH.'/images/spacer.gif';
		if(!file_exists($imgPath)) throw new Exception('image not found!');
		$filesize=filesize($imgPath); 	 
		header("Pragma: public"); 
		header("Cache-Control: no-cache, must-revalidate");				
		header('Content-Type: image/gif');
		header('Content-Length: '.$filesize); 
		header("Content-Disposition: inline; filename=spacer.gif");
		header("Content-Transfer-Encoding: binary");
		
		$fp = fopen($imgPath, 'r'); 
		$file_buffer = fread($fp, $filesize); 
		fclose ($fp);			
		print $file_buffer;
	}
		
}

?>