<?php  

if(!defined('ParticleTraffic_PATH')) die;

class ParticleTrafficVisit {

	protected $traffic_visit_id;
	protected $session_id;
	protected $cookies_off_id;
	protected $ip;
	protected $host_name;
	protected $users_id;
	protected $book_id;
	protected $referrer_url;
	protected $search_terms;
	protected $resolution;
	protected $platform;
	protected $browser;
	protected $browser_version;
	protected $flash_version;
	protected $created;
	protected $modified; 
		
	public function __construct(){
		$this->db = ParticleTrafficDB::get_instance();
	}		
		
	public function isVisitActive(){
		$sql='SELECT count(*) FROM '.ParticleTrafficTracker::$hits_table.' WHERE traffic_visits_id='.intval($this->traffic_visit_id).' AND created>'.intval(date('U')-ParticleTrafficTracker::$visitTimeout).' ORDER BY created DESC'; 
		$isActiveSession=$this->db->get_field($sql); 
		return ($isActiveSession)?1:0;
	}	 	
		
	//call any get method with a property type reference ($obj->property)
	public function __get($property){
		$method="get_{$property}";
		if(method_exists($this,$method)) return $this->$method();
	}

	function get_traffic_visit_id(){ return $this->traffic_visit_id;}
	function set_traffic_visit_id($traffic_visit_id){ $this->traffic_visit_id=$traffic_visit_id; }

	function get_session_id(){ return $this->session_id;} 
	function set_session_id($session_id){ $this->session_id=$session_id; }

	function get_cookies_off_id(){ return $this->cookies_off_id;} 
	function set_cookies_off_id($cookies_off_id){ $this->cookies_off_id=$cookies_off_id; }

	function get_ip(){ return $this->ip;}
	function set_ip($ip){ $this->ip=$ip; }

	function get_host_name(){ return $this->host_name;}
	function set_host_name($host_name){ $this->host_name=$host_name;}

	function get_users_id(){ return $this->users_id;}
	function set_users_id($users_id){ $this->users_id=$users_id; }

	function get_book_id(){ return $this->book_id;}
	function set_book_id($book_id){ $this->book_id=$book_id; }

	function get_referrer_url(){ return $this->referrer_url;}
	function set_referrer_url($referrer_url){ $this->referrer_url=$referrer_url; }

	function get_search_terms(){ return $this->search_terms;} 
	function set_search_terms($search_terms){ $this->search_terms=$search_terms; }

	function get_resolution(){ return $this->resolution;} 
	function set_resolution($resolution){ $this->resolution=$resolution; }

	function get_platform(){ return $this->platform;} 
	function set_platform($platform){ $this->platform=$platform; }

	function get_browser(){ return $this->browser;}
	function set_browser($browser){ $this->browser=$browser; }

	function get_browser_version(){ return $this->browser_version;}
	function set_browser_version($browser_version){ $this->browser_version=$browser_version; }

	function get_flash_version(){ return $this->flash_version;}
	function set_flash_version($flash_version){ $this->flash_version=$flash_version; }

	function get_created(){ return $this->created;}
	function set_created($created){ $this->created=$created; }

	function get_modified(){ return $this->modified;}
	function set_modified($modified){ $this->modified=$modified; }
	
	static function retrieveBySession($session_id=''){ 
		$visit = new ParticleTrafficVisit();
		$sql='SELECT * FROM '.ParticleTrafficTracker::$visits_table .' WHERE session_id="'.$session_id.'" ORDER BY created DESC LIMIT 1';
		$db = ParticleTrafficDB::get_instance();
		$row=$db->get_row($sql);
		if(!$row) return NULL;
		$visit->array_to_object($row);
		return $visit;		
	}
	
	static function retrieveByCookiesOffId($cookies_off_id=''){ 
		$visit = new ParticleTrafficVisit();
		$sql='SELECT * FROM '.ParticleTrafficTracker::$visits_table .' WHERE cookies_off_id="'.$cookies_off_id.'" ORDER BY created DESC LIMIT 1';
		$db = ParticleTrafficDB::get_instance();
		$row=$db->get_row($sql);
		if(!$row) return NULL;
		$visit->array_to_object($row);
		return $visit;		
	}	
	
	function save(){
		if(!$this->traffic_visit_id) $this->create();
		else $this->update();
	}
	
	function create(){ 
		if (($this->get_traffic_visit_id())<=0)
			$this->set_traffic_visit_id($this->db->nextID('traffic_visit_id',ParticleTrafficTracker::$visits_table));
		$this->set_created( time() );
		$this->set_modified( time() );
		$sql="INSERT INTO ".ParticleTrafficTracker::$visits_table ." SET 
			traffic_visit_id= ".intval($this->get_traffic_visit_id() )." ,
			session_id= '{$this->db->escape($this->get_session_id())}',
			cookies_off_id= '{$this->db->escape($this->get_cookies_off_id())}',
			ip= '{$this->db->escape($this->get_ip())}',
			host_name= '{$this->db->escape($this->get_host_name())}',
			users_id= ".intval($this->get_users_id() )." ,
			book_id= ".intval($this->get_book_id() )." ,
			referrer_url= '{$this->db->escape($this->get_referrer_url())}',
			search_terms= '{$this->db->escape($this->get_search_terms())}',
			resolution= '{$this->db->escape($this->get_resolution())}',
			platform= '{$this->db->escape($this->get_platform())}',
			browser= '{$this->db->escape($this->get_browser())}',
			browser_version= '{$this->db->escape($this->get_browser_version())}',
			flash_version= ".intval($this->get_flash_version() )." ,
			created= ".intval($this->get_created() )." ,
			modified= ".intval($this->get_modified() )." ";
		$queryResult=$this->db->query($sql); 
		$this->set_traffic_visit_id( $this->db->maxID('traffic_visit_id',ParticleTrafficTracker::$visits_table) );  
		if (!$queryResult) $queryResult=0; 
		return $queryResult; 
	}
	
	function update(){   
		$this->set_modified( time() );
		$sql="UPDATE ".ParticleTrafficTracker::$visits_table ." SET 
			traffic_visit_id= ".floatval($this->get_traffic_visit_id()).",
			session_id= '".$this->db->escape($this->get_session_id())."',
			cookies_off_id= '".$this->db->escape($this->get_cookies_off_id())."',
			ip= '".$this->db->escape($this->get_ip())."',
			host_name= '".$this->db->escape($this->get_host_name())."',
			users_id= ".floatval($this->get_users_id()).",
			book_id= ".floatval($this->get_book_id()).",
			referrer_url= '".$this->db->escape($this->get_referrer_url())."',
			search_terms= '".$this->db->escape($this->get_search_terms())."',
			resolution= '".$this->db->escape($this->get_resolution())."',
			platform= '".$this->db->escape($this->get_platform())."',
			browser= '".$this->db->escape($this->get_browser())."',
			browser_version= '".$this->db->escape($this->get_browser_version())."',
			flash_version= ".floatval($this->get_flash_version()).",
			modified= ".floatval($this->get_modified())." WHERE ";
		$sql.= "traffic_visit_id=".$this->traffic_visit_id;
		$queryResult=$this->db->query($sql); 
		if (!$queryResult) $queryResult=0; 
		return $queryResult; 
	}
	
	function delete(){
		$sql='DELETE FROM '.ParticleTrafficTracker::$visits_table .' WHERE 
			traffic_visit_id = '.$this->get_traffic_visit_id();
		$this->db->query($sql); 
		$this->set_traffic_visit_id(-1); 
	} 	
	
	function array_to_object($ob_array){
		if( !is_array($ob_array) ) return;
		foreach($ob_array as $key=>$value){
			$set_method='set_'.$key;
			if ( method_exists($this,$set_method) )$this->$set_method($value);
		} 
		return $this;
	}	
}

?>